//
//  ADMMController.h
//  MusiCog
//
//  Created by James Maxwell on 2013-11-12.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@class mcEvent, ADMMModel, mcMusiCogController;

@interface ADMMController : NSObject

@property (weak, nonatomic) mcMusiCogController* musiCog;
@property (strong, nonatomic) ADMMModel* pitchModel;
@property (strong, nonatomic) ADMMModel* rhythmModel;
@property (assign, nonatomic) NSUInteger fileCount;
@property (assign, nonatomic) BOOL useRhythmicModulo;
@property (strong, nonatomic) NSNumber* modulo;

- (void) setPitchModel:(ADMMModel *)aModel;
- (ADMMModel*) pitchModel;
- (void) setRhythmModel:(ADMMModel *)aModel;
- (ADMMModel*) rhythmModel;

- (void) updateModelWithEvent:(mcEvent*)anEvent useRhythmicModulus:(NSNumber*)aModulo;
- (void) generatePitchSequenceOfLength:(NSUInteger)length;
- (void) generateSequenceOfDuration:(float)duration;
- (void) resetSums;

@end
