//
//  mcCMNode.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-07.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "mcCMModel.h"

@class mcMusiCogController, mcCMModel, mcCMLevel, mcCMEdge, mcEvent;

enum mcTier {
    eSchema,
    eInvariance,
    eIdentity
};
typedef enum mcTier mcTier;

@interface mcCMNode : NSObject<NSCopying>

@property (weak, nonatomic) mcCMLevel* level;
@property (assign, nonatomic) NSUInteger ID;
@property (assign, nonatomic) NSUInteger subTierNodeID;
@property (assign, nonatomic) NSUInteger schemaNodeID;
@property (assign, nonatomic) UInt8 depth;
@property (assign, nonatomic) enum mcTier tier;
@property (assign, nonatomic) enum mcModelType type;
@property (assign, nonatomic) UInt32 valueIdx;
@property (assign, nonatomic) char schemaChar;
@property (strong, nonatomic) NSString* schemaPath;

- (mcCMEdge*) searchForTransitionWithInput:(/*__unsafe_unretained*/ mcEvent*)anEvent;
- (mcCMEdge*) deepeningSearchForTransitionWithInput:(/*__unsafe_unretained*/ mcEvent*)anEvent;
- (mcCMEdge*) searchSiblingsForTransitionWithInput:(/*__unsafe_unretained*/ mcEvent *)anEvent;
- (mcCMEdge*) hasTransitionForInput:(/*__unsafe_unretained*/ mcEvent*)anInput;
- (mcCMNode*) schemaNode;
- (mcCMNode*) invarianceNode;
- (mcCMNode*) subTier;
- (mcCMNode*) probabilisticSuperTier;
- (id) initWithParent:(mcCMNode*)parentNode subTier:(mcCMNode*)subTier andEvent:(mcEvent*)anEvent;
- (id) initWithLevel:(/*__unsafe_unretained*/ mcCMLevel*)aLevel;

@end
