//
//  mcCMState.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-07.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@class mcCMNode, mcCMModel, mcCMLevel;

@interface mcCMState : NSObject <NSCopying>

@property (weak, nonatomic) mcCMModel* model;
@property (strong, nonatomic) NSMutableArray* levelStates;

- (mcCMNode*) stateForLevelNumber:(UInt16)levelNumber;
- (void) setState:(mcCMNode*)aState forLevelNumber:(UInt16)levelNumber;
- (void) updateWithInference:(/*__unsafe_unretained*/ mcCMNode*)inference;
- (void) revertLevelToRoot:(mcCMLevel*)aLevel;
- (NSArray*) flatStateRep;
- (id) initWithModel:(mcCMModel*)aModel;

@end
