//
//  mcCMStaticAssociation.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-24.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface mcCMStaticAssociation : NSObject

@property (retain, nonatomic) NSString* assocID;
@property (retain, nonatomic) id assocData;

@end

/*
 Static associations are used for associating arbitrary data of a particular type, which can be set by the assocID.
 For example, dynamics could be associated with an MCCMNode by creating a new MCCMAssociation with leftNode = <MCCMNode> and
 rightNode = <static association: assocID:"dynamic", assocData:84>. During recall, the dynamic for generation can be chosen
 by finding all associated "dynamic" items and making a weighted probabilistic choice based on the association strength.
 It might also be useful to have some "factory" methods that create static association objects for different types of
 data. These could provide some sort of quantization or clustering so that, for the dynamic example, the dynamics could
 be clustered into ranges representing something like dyanmic markings, or durations could be clustered by "articulation"
 (i.e., staccato, legato).
 */