//
//  mcPMController.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-09.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@class mcProductionModule, mcPlanner, mcMusiCogController, mcWMStream;

@interface mcPMController : NSObject

@property (weak, nonatomic) mcMusiCogController* musiCog;
@property (strong, nonatomic) mcProductionModule* PM;
@property (strong, nonatomic) mcPlanner* planner;
@property (assign, nonatomic) BOOL breakGenerationLoop;
@property (assign, nonatomic) BOOL generateContinuously;
@property (assign, nonatomic) BOOL generateNonRealTime;
@property (assign, nonatomic) BOOL useFutureEntropy;
@property (assign, nonatomic) BOOL lockToInferredModeAndTonality;
@property (assign, nonatomic) BOOL modeAndTonalityChosen;
@property (assign, nonatomic) float corpusModeConfidence;
@property (assign, nonatomic) UInt64 modeUpdateCounter;
@property (assign, nonatomic) BOOL useInferenceForBottomUpPlanModification;
@property (assign, nonatomic) BOOL monophonicGeneration;
@property (strong, nonatomic) NSNumber* beatsInBar;
@property (strong, nonatomic) NSNumber* barsToGenerate;
@property (assign, nonatomic) UInt16 chosenMode;
@property (assign, nonatomic) UInt16 chosenTonality;
@property (assign, nonatomic) BOOL randomMelodiesAreDiatonic;

// Some stats about generation
@property (assign, nonatomic) NSUInteger segmentsGenerated;
@property (assign, nonatomic) NSUInteger mismatchedPitchAndRhythmBranches;

- (void) generateTopDown;
- (void) generateBottomUp;
- (void) generateContinuationForStream:(mcWMStream*)aStream;
- (void) generateSetOf:(UInt16)count randomMelodiesOfDuration:(float)duration;
- (void) generateRandomMelodies;
- (void) handleNonRealTimeIterationForStreamID:(NSUInteger)sID;
- (id) initWithMusiCog:(mcMusiCogController*)mc;

@end
