//
//  mcPMTexture.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-24.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>

@class mcWMStream;

@interface mcPMTexture : NSObject

@property (strong, nonatomic) NSMutableArray* streams;
@property (strong, nonatomic) NSMutableArray* candidateNoteSequences;
@property (strong, nonatomic) NSMutableSet* accompaniment;
@property (strong, nonatomic) NSMutableArray* domainOfGeneration;
@property (strong, nonatomic) NSMutableArray* harmonicGrid;
@property (strong, nonatomic) NSMutableDictionary* renderMap;

- (UInt32) createTextureStreamFromPMStream:(mcWMStream*)aStream;
- (void) updateTextureStreamsForTime:(MusicTimeStamp)currentTime;
- (id) initWithStartTime:(MusicTimeStamp)start andEndTime:(MusicTimeStamp)end;

@end
