//
//  postHelper.h
//  HSMM_Modular
//
//  Created by James Maxwell on 10-01-20.
//  Copyright 2010 rubato-music.com. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface postHelper : NSObject

+ (NSString*)       pitchNameFromMIDIPitch:(NSInteger)MIDIPitch;
+ (NSString*)       modeFromModeID:(NSUInteger)modeID;
+ (NSArray*)        modes;

+ (void)			postIntMatrix:(NSString*) name data:(NSInteger*) aMatrix rows:(NSInteger) numRows cols:(NSInteger) numCols;
+ (void)            postUInt64Matrix:(NSString*) name data:(NSUInteger*) aMatrix rows:(NSInteger) numRows cols:(NSInteger) numCols filterValue:(NSUInteger) aVal;
+ (void)			postFloatMatrix:(NSString*) name data:(float*) aMatrix rows:(NSInteger) numRows cols:(NSInteger) numCols;
+ (void)            postUInt64Vector:(NSString*)name data:(UInt64*)aVector length:(NSInteger)vectorLength;
+ (void)			postIntVector:(NSString*) name data:(NSInteger*) aVector length:(NSInteger) vectorLength;
+ (void)			postUInt64Vector:(NSString*) name data:(UInt64*) aVector length:(NSInteger) vectorLength filterZeros:(BOOL)flag;
+ (void)			postLongVector:(NSString*) name data:(long*) aVector length:(NSInteger) vectorLength filterZeros:(BOOL)flag;
+ (void)			postFloatVector:(NSString*) name data:(float*) aVector length:(NSInteger) vectorLength filterZeros:(BOOL)flag;
+ (void)			postNSArray:(NSString*) name data:(NSArray*) anArray;
+ (void)            postNonZeroFloatsInNSArray:(NSString*)name data:(NSArray*)anArray;

+ (void)            postRect:(NSString*)name data:(NSRect)aRect;

+ (NSString*)		convertNSArrayToString:(NSString*) name data:(NSArray*) anArray;
+ (NSString*)       convertNSArrayToString:(NSArray *)anArray;
+ (NSString*)       convertNSArrayToCommaDelimitedString:(NSArray*)anArray;

@end
